[oe-commits] Laurentiu Palcu : scripts/postinst-intercepts: create separete hooks for multilib

git at git.openembedded.org git at git.openembedded.org
Wed May 22 16:08:53 UTC 2013


Module: openembedded-core.git
Branch: dylan
Commit: 324bb71d769955690d575b85f5a6670314fdd1f1
URL:    http://git.openembedded.org/?p=openembedded-core.git&a=commit;h=324bb71d769955690d575b85f5a6670314fdd1f1

Author: Laurentiu Palcu <laurentiu.palcu at intel.com>
Date:   Fri Apr 26 11:04:01 2013 +0300

scripts/postinst-intercepts: create separete hooks for multilib

When using multilib, the hooks for lib32/lib64 must be different because
the libdir/base_libdir point to different locations. Postinstalls
calling postint_intercept script must pass the mlprefix in the 3rd
argument.

(From OE-Core master rev: 2c5c6e3ffcd561c25a34603922b622449f677a34)

Signed-off-by: Laurentiu Palcu <laurentiu.palcu at intel.com>
Signed-off-by: Saul Wold <sgw at linux.intel.com>
Signed-off-by: Richard Purdie <richard.purdie at linuxfoundation.org>

---

 scripts/postinst-intercepts/postinst_intercept |   23 +++++++++++++++++++++--
 1 files changed, 21 insertions(+), 2 deletions(-)

diff --git a/scripts/postinst-intercepts/postinst_intercept b/scripts/postinst-intercepts/postinst_intercept
index ed32f27..27c2568 100755
--- a/scripts/postinst-intercepts/postinst_intercept
+++ b/scripts/postinst-intercepts/postinst_intercept
@@ -5,21 +5,40 @@
 # is valid. Also, if one wants to pass any variables to the intercept script from
 # the postinstall itself, they will be added immediately after the shebang line.
 #
-# Usage: postinst_intercept <intercept_script_name> <package_name> <var1=...> ... <varN=...>
+# Usage: postinst_intercept <intercept_script_name> <package_name> <mlprefix=...> <var1=...> ... <varN=...>
 #  * intercept_script_name - the name of the intercept script we want to change;
 #  * package_name - add the package_name to list of packages the intercept script
 #                   is used for;
+#  * mlprefix=... - this one is needed in order to have separate hooks for multilib.
 #  * var1=... - var1 will have the value we provide in the intercept script. This
 #               is useful when we want to pass on variables like ${libdir} to
 #               the intercept script;
 #
-[ $# -lt 2 ] && exit 1
+[ $# -lt 3 ] && exit 1
 
 intercept_script=$INTERCEPT_DIR/$1 && shift
 package_name=$1 && shift
+mlprefix=$(echo $1 |sed -ne "s/^mlprefix=\(.*\)-/\1/p") && shift
 
+# if the hook we want to install does not exist, then there's nothing we can do
 [ -f "$intercept_script" ] || exit 1
 
+# if the postinstall wanting to install the hook belongs to a multilib package,
+# then we'd better have a separate hook for this because the default ${libdir} and
+# ${base_libdir} will point to the wrong locations
+if [ -n "$mlprefix" ]; then
+	ml_intercept_script=$intercept_script-$mlprefix
+	# if the multilib hook does not exist, create it from the default one
+	if [ ! -f "$ml_intercept_script" ]; then
+		cp $intercept_script $ml_intercept_script
+
+		# clear the ##PKGS: line and the already set variables
+		[ -x "$ml_intercept_script" ] && sed -i -e "2,$(($#+1)) {/.*/d}" -e "/^##PKGS: .*/d" $ml_intercept_script
+	fi
+
+	intercept_script=$ml_intercept_script
+fi
+
 chmod +x "$intercept_script"
 
 pkgs_line="$(cat $intercept_script|grep "##PKGS:")"



More information about the Openembedded-commits mailing list